Index: /pjproject/main/pjsip/include/pjsip/sip_msg.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_msg.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_msg.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_MSG_H__
@@ -261,5 +260,5 @@
 #define PJSIP_DECL_HDR_MEMBER(hdr)   \
     /** List members. */	\
-    PJ_DECL_LIST_MEMBER(hdr)	\
+    PJ_DECL_LIST_MEMBER(hdr);	\
     /** Header type */		\
     pjsip_hdr_e	    type;	\
@@ -269,5 +268,5 @@
     pj_str_t	    sname;		\
     /** Virtual function table. */	\
-    pjsip_hdr_vptr *vptr;
+    pjsip_hdr_vptr *vptr
 
 
@@ -276,8 +275,8 @@
  * message. All header fields can be typecasted to this type.
  */
-typedef struct pjsip_hdr
-{
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_hdr)
-} pjsip_hdr;
+struct pjsip_hdr
+{
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_hdr);
+};
 
 
@@ -688,5 +687,5 @@
  *		value if the message is too large for the specified buffer.
  */
-PJ_DECL(int) pjsip_msg_print( pjsip_msg *msg, char *buf, pj_size_t size);
+PJ_DECL(pj_ssize_t) pjsip_msg_print(pjsip_msg *msg, char *buf, pj_size_t size);
 
 /**
@@ -708,5 +707,5 @@
 typedef struct pjsip_generic_string_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_string_hdr) /**< Standard header field. */
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_string_hdr); /**< Standard header field. */
     pj_str_t hvalue;				    /**< hvalue */
 } pjsip_generic_string_hdr;
@@ -757,5 +756,5 @@
 typedef struct pjsip_generic_int_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_int_hdr) /**< Standard header field. */
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_int_hdr); /**< Standard header field. */
     pj_int32_t ivalue;				    /**< ivalue */
 } pjsip_generic_int_hdr;
@@ -806,5 +805,5 @@
 typedef struct pjsip_generic_array_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_array_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_array_hdr);
     unsigned	count;					/**< Number of elements. */
     pj_str_t	values[PJSIP_GENERIC_ARRAY_MAX_COUNT];	/**< Elements.		 */
@@ -887,5 +886,5 @@
 typedef struct pjsip_cid_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_cid_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_cid_hdr);
     pj_str_t id;	    /**< Call-ID string. */
 } pjsip_cid_hdr;
@@ -918,5 +917,5 @@
 typedef struct pjsip_clen_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_clen_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_clen_hdr);
     int len;	/**< Content length. */
 } pjsip_clen_hdr;
@@ -946,5 +945,5 @@
 typedef struct pjsip_cseq_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_cseq_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_cseq_hdr);
     int		    cseq;	/**< CSeq number. */
     pjsip_method    method;	/**< CSeq method. */
@@ -978,5 +977,5 @@
 typedef struct pjsip_contact_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_contact_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_contact_hdr);
     int		    star;	    /**< The contact contains only a '*' character */
     pjsip_uri *uri;	    /**< URI in the contact. */
@@ -1011,5 +1010,5 @@
 typedef struct pjsip_ctype_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_ctype_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_ctype_hdr);
     pjsip_media_type media; /**< Media type. */
 } pjsip_ctype_hdr;
@@ -1062,5 +1061,5 @@
 typedef struct pjsip_fromto_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_fromto_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_fromto_hdr);
     pjsip_uri  *uri;	    /**< URI in From/To header. */
     pj_str_t	     tag;	    /**< Header "tag" parameter. */
@@ -1171,5 +1170,5 @@
 typedef struct pjsip_routing_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_routing_hdr)  /**< Generic header fields. */
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_routing_hdr);  /**< Generic header fields. */
     pjsip_name_addr  name_addr;	  /**< The URL in the Route/Record-Route header. */
     pj_str_t	     other_param; /** Other parameter. */
@@ -1328,5 +1327,5 @@
 typedef struct pjsip_via_hdr
 {
-    PJSIP_DECL_HDR_MEMBER(struct pjsip_via_hdr)
+    PJSIP_DECL_HDR_MEMBER(struct pjsip_via_hdr);
     pj_str_t	     transport;	    /**< Transport type. */
     pjsip_host_port  sent_by;	    /**< Host and optional port */
Index: /pjproject/main/pjsip/include/pjsip/sip_parser.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_parser.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_parser.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_PARSER_H__
@@ -11,5 +10,5 @@
 
 #include <pjsip/sip_types.h>
-#include <pj/scanner.h>
+#include <pjlib-util/scanner.h>
 #include <pj/list.h>
 
@@ -52,5 +51,5 @@
 typedef struct pjsip_parser_err_report
 {
-    PJ_DECL_LIST_MEMBER(struct pjsip_parser_err_report)
+    PJ_DECL_LIST_MEMBER(struct pjsip_parser_err_report);
     int		exception_code;	/**< Error exception (e.g. PJSIP_SYN_ERR_EXCEPTION) */
     int		line;		/**< Line number. */
@@ -58,4 +57,15 @@
     pj_str_t	hname;		/**< Header name, if any. */
 } pjsip_parser_err_report;
+
+
+/**
+ * Parsing context, the default argument for parsing functions.
+ */
+typedef struct pjsip_parse_ctx
+{
+    pj_scanner      *scanner;   /**< The scanner.       */
+    pj_pool_t       *pool;      /**< The pool.          */
+    pjsip_rx_data   *rdata;     /**< Optional rdata.    */
+} pjsip_parse_ctx;
 
 
@@ -77,5 +87,5 @@
  *        can be terminated when seeing EOF.
  */
-typedef void* (pjsip_parse_hdr_func)(pj_scanner *scanner, pj_pool_t *pool);
+typedef pjsip_hdr* (pjsip_parse_hdr_func)(pjsip_parse_ctx *context);
 
 /**
@@ -95,6 +105,5 @@
  * @param fptr		The pointer to function to parser the header.
  *
- * @return		zero if success.
- * @see pjsip_parse_hdr_func
+ * @return		PJ_SUCCESS if success, or the appropriate error code.
  */
 PJ_DECL(pj_status_t) pjsip_register_hdr_parser( const char *hname,
@@ -186,4 +195,25 @@
 
 /**
+ * Parse a packet buffer and build a rdata. The resulting message will be
+ * stored in \c msg field in the \c rdata. This behaves pretty much like
+ * #pjsip_parse_msg(), except that it will also initialize the header fields
+ * in the \c rdata.
+ *
+ * This function is normally called by the transport layer.
+ *
+ * @param buf           The input buffer
+ * @param buf		The input buffer, which size must be at least (size+1)
+ *			because the function will temporarily put NULL 
+ *			termination at the end of the buffer during parsing.
+ * @param size		The length of the string (not counting NULL terminator).
+ * @param rdata         The receive data buffer to store the message and
+ *                      its elements.
+ *
+ * @return              The message inside the rdata if successfull, or NULL.
+ */
+PJ_DECL(pjsip_msg *) pjsip_parse_rdata( char *buf, pj_size_t size,
+                                        pjsip_rx_data *rdata );
+
+/**
  * Check incoming packet to see if a (probably) valid SIP message has been 
  * received.
@@ -194,8 +224,10 @@
  *			the size of the SIP message (including body, if any).
  *
- * @return		PJ_TRUE (1) if a message is found.
- */
-PJ_DECL(pj_bool_t) pjsip_find_msg( const char *buf, pj_size_t size, 
-				   pj_bool_t is_datagram, pj_size_t *msg_size);
+ * @return		PJ_SUCCESS if a message is found, or an error code.
+ */
+PJ_DECL(pj_status_t) pjsip_find_msg(const char *buf, 
+                                    pj_size_t size, 
+				    pj_bool_t is_datagram, 
+                                    pj_size_t *msg_size);
 
 /**
@@ -248,5 +280,5 @@
  */
 extern
-pj_char_spec	pjsip_HOST_SPEC,	    /* For scanning host part. */
+pj_cis_t	pjsip_HOST_SPEC,	    /* For scanning host part. */
 		pjsip_DIGIT_SPEC,	    /* Decimal digits */
 		pjsip_ALPHA_SPEC,	    /* Alpha (A-Z, a-z) */
Index: /pjproject/main/pjsip/include/pjsip/sip_private.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_private.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_private.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_PRIVATE_H__
@@ -27,7 +26,9 @@
  * @param cb Callback to be called to receive messages from transport.
  */
-PJ_DECL(pjsip_transport_mgr*) pjsip_transport_mgr_create( pj_pool_t *pool,
-							  pjsip_endpoint *endpt,
-							  void (*cb)(pjsip_endpoint *,pjsip_rx_data *));
+PJ_DECL(pj_status_t) pjsip_transport_mgr_create( pj_pool_t *pool,
+						 pjsip_endpoint *endpt,
+						 void (*cb)(pjsip_endpoint *,
+							    pjsip_rx_data *),
+						 pjsip_transport_mgr **);
 
 
@@ -36,5 +37,5 @@
  * @param mgr Transport manager to be destroyed.
  */
-PJ_DECL(void) pjsip_transport_mgr_destroy( pjsip_transport_mgr *mgr );
+PJ_DECL(pj_status_t) pjsip_transport_mgr_destroy( pjsip_transport_mgr *mgr );
 
 /**
Index: /pjproject/main/pjsip/include/pjsip/sip_resolve.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_resolve.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_resolve.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_RESOLVE_H__
Index: /pjproject/main/pjsip/include/pjsip/sip_transaction.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_transaction.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_transaction.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_TRANSACTION_H__
@@ -12,6 +11,4 @@
 #include <pjsip/sip_msg.h>
 #include <pjsip/sip_resolve.h>
-//#include <pjsip/sip_config.h>
-//#include <pjsip/sip_endpoint.h>
 #include <pj/timer.h>
 
@@ -24,4 +21,5 @@
  */
 
+/* Forward decl. */
 struct pjsip_transaction;
 
@@ -62,31 +60,54 @@
 struct pjsip_transaction
 {
-    pj_pool_t		       *pool;
-    pjsip_endpoint	       *endpt;
-    char			obj_name[PJ_MAX_OBJ_NAME];
-    pjsip_role_e		role;
-    int				status_code;
-    pjsip_tsx_state_e		state;
-    int (*state_handler)(struct pjsip_transaction *, pjsip_event *);
-
-    pj_mutex_t		       *mutex;
-    pjsip_method		method;
-    int				cseq;
-    pj_str_t			transaction_key;
-    pj_str_t			branch;
-
-    pjsip_tsx_transport_state_e	transport_state;
-    pjsip_host_port		dest_name;
-    int				current_addr;
-    pjsip_server_addresses	remote_addr;
-    pjsip_transport_t	       *transport;
-
-    pjsip_tx_data	       *last_tx;
-    int				has_unsent_msg;
-    int				handle_ack;
-    int				retransmit_count;
-
-    pj_timer_entry		retransmit_timer;
-    pj_timer_entry		timeout_timer;
+    /*
+     * Administrivia
+     */
+    pj_pool_t		       *pool;           /**< Pool owned by the tsx. */
+    pjsip_endpoint	       *endpt;          /**< Endpoint instance.     */
+    pj_mutex_t		       *mutex;          /**< Mutex for this tsx.    */
+    char			obj_name[PJ_MAX_OBJ_NAME];  /**< Tsx name.  */
+    int                         tracing;        /**< Tracing enabled?       */
+
+    /*
+     * Transaction identification.
+     */
+    pjsip_role_e		role;           /**< Role (UAS or UAC)      */
+    pjsip_method		method;         /**< The method.            */
+    int				cseq;           /**< The CSeq               */
+    pj_str_t			transaction_key;/**< hash table key.        */
+    pj_str_t			branch;         /**< The branch Id.         */
+
+    /*
+     * State and status.
+     */
+    int				status_code;    /**< Last status code seen. */
+    pjsip_tsx_state_e		state;          /**< State.                 */
+    int				handle_ack;     /**< Should we handle ACK?  */
+
+    /** Handler according to current state. */
+    pj_status_t (*state_handler)(struct pjsip_transaction *, pjsip_event *);
+
+    /*
+     * Transport.
+     */
+    pjsip_tsx_transport_state_e	transport_state;/**< Transport's state.     */
+    pjsip_host_port		dest_name;      /**< Destination address.   */
+    pjsip_server_addresses	remote_addr;    /**< Addresses resolved.    */
+    int				current_addr;   /**< Address currently used. */
+
+    pjsip_transport_t	       *transport;      /**< Transport to use.      */
+
+    /*
+     * Messages and timer.
+     */
+    pjsip_tx_data	       *last_tx;        /**< Msg kept for retrans.  */
+    int				has_unsent_msg; /**< Non-zero if tsx need to 
+                                                     transmit msg once resolver
+                                                     completes.             */
+    int				retransmit_count;/**< Retransmission count. */
+    pj_timer_entry		retransmit_timer;/**< Retransmit timer.     */
+    pj_timer_entry		timeout_timer;  /**< Timeout timer.         */
+
+    /** Module specific data. */
     void		       *module_data[PJSIP_MAX_MODULE];
 };
@@ -94,8 +115,24 @@
 
 /** 
- * Init transaction as UAC.
- * @param tsx the transaction.
- * @param tdata the transmit data.
- * @return PJ_SUCCESS if successfull.
+ * Init transaction as UAC from the specified transmit data (\c tdata).
+ * The transmit data must have a valid \c Request-Line and \c CSeq header.
+ * If \c Route headers are present, it will be used to calculate remote
+ * destination.
+ *
+ * If \c Via header does not exist, it will be created along with a unique
+ * \c branch parameter. If it exists and contains branch parameter, then
+ * the \c branch parameter will be used as is as the transaction key.
+ *
+ * The \c Route headers in the transmit data, if present, are used to 
+ * calculate remote destination.
+ *
+ * At the end of the function, the transaction will start resolving the
+ * addresses of remote server to contact. Transport will be acquired as soon
+ * as the resolving job completes.
+ *
+ * @param tsx       The transaction.
+ * @param tdata     The transmit data.
+ *
+ * @return          PJ_SUCCESS if successfull.
  */
 PJ_DECL(pj_status_t) pjsip_tsx_init_uac( pjsip_transaction *tsx, 
@@ -104,6 +141,8 @@
 /**
  * Init transaction as UAS.
- * @param tsx the transaction to be initialized.
- * @param rdata the received incoming request.
+ *
+ * @param tsx       The transaction to be initialized.
+ * @param rdata     The received incoming request.
+ *
  * @return PJ_SUCCESS if successfull.
  */
@@ -113,6 +152,7 @@
 /**
  * Process incoming message for this transaction.
- * @param tsx the transaction.
- * @param rdata the incoming message.
+ *
+ * @param tsx       The transaction.
+ * @param rdata     The incoming message.
  */
 PJ_DECL(void) pjsip_tsx_on_rx_msg( pjsip_transaction *tsx,
@@ -121,6 +161,7 @@
 /**
  * Transmit message with this transaction.
- * @param tsx the transaction.
- * @param tdata the outgoing message.
+ *
+ * @param tsx       The transaction.
+ * @param tdata     The outgoing message.
  */
 PJ_DECL(void) pjsip_tsx_on_tx_msg( pjsip_transaction *tsx,
@@ -135,6 +176,7 @@
  * transaction will comply with RFC-3261, i.e. it will set itself to 
  * TERMINATED state when it receives 2xx/INVITE.
- * @param tsx The transaction.
- * @param tdata The ACK request.
+ *
+ * @param tsx       The transaction.
+ * @param tdata     The ACK request.
  */
 PJ_DECL(void) pjsip_tsx_on_tx_ack( pjsip_transaction *tsx,
@@ -142,7 +184,8 @@
 
 /**
- * Forcely terminate transaction.
- * @param tsx the transaction.
- * @param code the status code to report.
+ * Force terminate transaction.
+ *
+ * @param tsx       The transaction.
+ * @param code      The status code to report.
  */
 PJ_DECL(void) pjsip_tsx_terminate( pjsip_transaction *tsx,
@@ -152,15 +195,19 @@
  * Create transaction key, which is used to match incoming requests 
  * or response (retransmissions) against transactions.
- * @param pool The pool
- * @param key Output key.
- * @param role The role of the transaction.
- * @param method The method to be put as a key. 
- * @param rdata The received data to calculate.
- */
-PJ_DECL(void) pjsip_tsx_create_key( pj_pool_t *pool,
-				    pj_str_t *key,
-				    pjsip_role_e role,
-				    const pjsip_method *method,
-				    const pjsip_rx_data *rdata );
+ *
+ * @param pool      The pool
+ * @param key       Output key.
+ * @param role      The role of the transaction.
+ * @param method    The method to be put as a key. 
+ * @param rdata     The received data to calculate.
+ *
+ * @return          PJ_SUCCESS or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_tsx_create_key( pj_pool_t *pool,
+				           pj_str_t *key,
+				           pjsip_role_e role,
+				           const pjsip_method *method,
+				           const pjsip_rx_data *rdata );
+
 
 /**
@@ -184,5 +231,5 @@
 
 /* Thread Local Storage ID for transaction lock (initialized by endpoint) */
-extern int pjsip_tsx_lock_tls_id;
+extern long pjsip_tsx_lock_tls_id;
 
 PJ_END_DECL
Index: /pjproject/main/pjsip/include/pjsip/sip_types.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_types.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_types.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_TYPES_H__
@@ -74,4 +73,9 @@
 
 /**
+ * Forward declaration for header field (sip_msg.h).
+ */
+typedef struct pjsip_hdr pjsip_hdr;
+
+/**
  * Forward declaration for URI (sip_uri.h).
  */
@@ -135,4 +139,23 @@
 
 
+/**
+ * Convert exception ID into pj_status_t status.
+ *
+ * @param exception_id  Exception Id.
+ *
+ * @return              Error code for the specified exception Id.
+ */
+PJ_DECL(pj_status_t) pjsip_exception_to_status(int exception_id);
+
+/**
+ * Return standard pj_status_t status from current exception.
+ */
+#define PJSIP_RETURN_EXCEPTION() pjsip_exception_to_status(PJ_GET_EXCEPTION())
+
+/**
+ * Attributes to inform that the function may throw exceptions.
+ */
+#define PJSIP_THROW_SPEC(list)
+
 #endif	/* __PJSIP_SIP_TYPES_H__ */
 
Index: /pjproject/main/pjsip/include/pjsip/sip_uri.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip/sip_uri.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip/sip_uri.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_SIP_URI_H__
Index: /pjproject/main/pjsip/include/pjsip_core.h
===================================================================
--- /pjproject/main/pjsip/include/pjsip_core.h	(revision 42)
+++ /pjproject/main/pjsip/include/pjsip_core.h	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJSIP_CORE_H__
Index: /pjproject/main/pjsip/src/pjsip/sip_auth.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_auth.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_auth.c	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_auth.h>
@@ -6,9 +5,11 @@
 #include <pjsip/sip_transport.h>
 #include <pjsip/sip_endpoint.h>
-#include <pj/md5.h>
+#include <pjlib-util/md5.h>
 #include <pj/log.h>
 #include <pj/string.h>
 #include <pj/pool.h>
 #include <pj/guid.h>
+#include <pj/assert.h>
+#include <pj/ctype.h>
 
 /* Length of digest string. */
@@ -147,5 +148,5 @@
     p = qop.ptr;
     while (*p) {
-	*p = (char)tolower(*p);
+	*p = (char)pj_tolower(*p);
 	++p;
     }
@@ -218,5 +219,5 @@
 	cred->qop = pjsip_AUTH_STR;
 	cred->nc.ptr = pj_pool_alloc(pool, 16);
-	sprintf(cred->nc.ptr, "%06u", nc);
+	pj_snprintf(cred->nc.ptr, 16, "%06u", nc);
 
 	if (cnonce && cnonce->slen) {
@@ -485,5 +486,5 @@
 {
     unsigned i;
-    PJ_UNUSED_ARG(scheme)
+    PJ_UNUSED_ARG(scheme);
     for (i=0; i<count; ++i) {
 	if (pj_stricmp(&cred[i].realm, realm) == 0)
@@ -716,5 +717,5 @@
     pjsip_via_hdr *via;
 
-    PJ_UNUSED_ARG(endpt)
+    PJ_UNUSED_ARG(endpt);
 
     pj_assert(rdata->msg->type == PJSIP_RESPONSE_MSG);
Index: /pjproject/main/pjsip/src/pjsip/sip_auth_msg.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_auth_msg.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_auth_msg.c	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_auth_msg.h>
@@ -7,5 +6,6 @@
 #include <pj/list.h>
 #include <pj/string.h>
-#include <pjsip/print.h>
+#include <pj/assert.h>
+#include <pjsip/print_util.h>
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -68,7 +68,7 @@
 static int print_pgp_credential(pjsip_pgp_credential *cred, char *buf, pj_size_t size)
 {
-    PJ_UNUSED_ARG(cred)
-    PJ_UNUSED_ARG(buf)
-    PJ_UNUSED_ARG(size)
+    PJ_UNUSED_ARG(cred);
+    PJ_UNUSED_ARG(buf);
+    PJ_UNUSED_ARG(size);
     return -1;
 }
@@ -213,7 +213,7 @@
 			        char *buf, pj_size_t size)
 {
-    PJ_UNUSED_ARG(chal)
-    PJ_UNUSED_ARG(buf)
-    PJ_UNUSED_ARG(size)
+    PJ_UNUSED_ARG(chal);
+    PJ_UNUSED_ARG(buf);
+    PJ_UNUSED_ARG(size);
     return -1;
 }
Index: /pjproject/main/pjsip/src/pjsip/sip_auth_parser.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_auth_parser.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_auth_parser.c	(revision 43)
@@ -1,20 +1,24 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_auth_parser.h>
 #include <pjsip/sip_auth_msg.h>
 #include <pjsip/sip_parser.h>
+#include <pj/assert.h>
 #include <pj/string.h>
 #include <pj/except.h>
 
-static pjsip_authorization_hdr*	      parse_hdr_authorization( pj_scanner *scanner, pj_pool_t *pool);
-static pjsip_proxy_authorization_hdr* parse_hdr_proxy_authorization( pj_scanner *scanner, pj_pool_t *pool);
-static pjsip_www_authenticate_hdr*    parse_hdr_www_authenticate( pj_scanner *scanner, pj_pool_t *pool);
-static pjsip_proxy_authenticate_hdr*  parse_hdr_proxy_authenticate( pj_scanner *scanner, pj_pool_t *pool);
-
-static void parse_digest_credential( pj_scanner *scanner, pj_pool_t *pool, pjsip_digest_credential *cred);
-static void parse_pgp_credential( pj_scanner *scanner, pj_pool_t *pool, pjsip_pgp_credential *cred);
-static void parse_digest_challenge( pj_scanner *scanner, pj_pool_t *pool, pjsip_digest_challenge *chal);
-static void parse_pgp_challenge( pj_scanner *scanner, pj_pool_t *pool, pjsip_pgp_challenge *chal);
+static pjsip_hdr* parse_hdr_authorization       ( pjsip_parse_ctx *ctx );
+static pjsip_hdr* parse_hdr_proxy_authorization ( pjsip_parse_ctx *ctx );
+static pjsip_hdr* parse_hdr_www_authenticate    ( pjsip_parse_ctx *ctx );
+static pjsip_hdr* parse_hdr_proxy_authenticate  ( pjsip_parse_ctx *ctx );
+
+static void parse_digest_credential ( pj_scanner *scanner, pj_pool_t *pool, 
+                                      pjsip_digest_credential *cred);
+static void parse_pgp_credential    ( pj_scanner *scanner, pj_pool_t *pool, 
+                                      pjsip_pgp_credential *cred);
+static void parse_digest_challenge  ( pj_scanner *scanner, pj_pool_t *pool, 
+                                      pjsip_digest_challenge *chal);
+static void parse_pgp_challenge     ( pj_scanner *scanner, pj_pool_t *pool,
+                                      pjsip_pgp_challenge *chal);
 
 const pj_str_t	pjsip_USERNAME_STR =	    { "username", 8 },
@@ -44,10 +48,11 @@
 
 
-static void parse_digest_credential( pj_scanner *scanner, pj_pool_t *pool, pjsip_digest_credential *cred)
+static void parse_digest_credential( pj_scanner *scanner, pj_pool_t *pool, 
+                                     pjsip_digest_credential *cred)
 {
     for (;;) {
 	pj_str_t name, value;
 
-	pjsip_parse_param_imp(scanner, &name, &value, PJSIP_PARSE_REMOVE_QUOTE);
+	pjsip_parse_param_imp(scanner, &name, &value,PJSIP_PARSE_REMOVE_QUOTE);
 
 	if (!pj_stricmp(&name, &pjsip_USERNAME_STR)) {
@@ -82,9 +87,9 @@
 
 	} else {
-	    pjsip_concat_param_imp(&cred->other_param, pool, &name, &value, ',');
+	    pjsip_concat_param_imp(&cred->other_param,pool,&name,&value, ',');
 	}
 
 	/* Eat comma */
-	if (!pj_scan_is_eof(scanner) && *scanner->current == ',')
+	if (!pj_scan_is_eof(scanner) && *scanner->curptr == ',')
 	    pj_scan_get_char(scanner);
 	else
@@ -93,19 +98,21 @@
 }
 
-static void parse_pgp_credential( pj_scanner *scanner, pj_pool_t *pool, pjsip_pgp_credential *cred)
-{
-    PJ_UNUSED_ARG(scanner)
-    PJ_UNUSED_ARG(pool)
-    PJ_UNUSED_ARG(cred)
+static void parse_pgp_credential( pj_scanner *scanner, pj_pool_t *pool, 
+                                  pjsip_pgp_credential *cred)
+{
+    PJ_UNUSED_ARG(scanner);
+    PJ_UNUSED_ARG(pool);
+    PJ_UNUSED_ARG(cred);
 
     PJ_THROW(PJSIP_SYN_ERR_EXCEPTION);
 }
 
-static void parse_digest_challenge( pj_scanner *scanner, pj_pool_t *pool, pjsip_digest_challenge *chal)
+static void parse_digest_challenge( pj_scanner *scanner, pj_pool_t *pool, 
+                                    pjsip_digest_challenge *chal)
 {
     for (;;) {
 	pj_str_t name, value;
 
-	pjsip_parse_param_imp(scanner, &name, &value, PJSIP_PARSE_REMOVE_QUOTE);
+	pjsip_parse_param_imp(scanner, &name, &value,PJSIP_PARSE_REMOVE_QUOTE);
 
 	if (!pj_stricmp(&name, &pjsip_REALM_STR)) {
@@ -122,6 +129,9 @@
 
 	} else if (!pj_stricmp(&name, &pjsip_STALE_STR)) {
-	    if (!pj_stricmp(&value, &pjsip_TRUE_STR) || !pj_stricmp(&value, &pjsip_QUOTED_TRUE_STR))
+	    if (!pj_stricmp(&value, &pjsip_TRUE_STR) || 
+                !pj_stricmp(&value, &pjsip_QUOTED_TRUE_STR))
+            {
 		chal->stale = 1;
+            }
 
 	} else if (!pj_stricmp(&name, &pjsip_ALGORITHM_STR)) {
@@ -133,9 +143,10 @@
 
 	} else {
-	    pjsip_concat_param_imp(&chal->other_param, pool, &name, &value, ',');
+	    pjsip_concat_param_imp(&chal->other_param, pool, 
+                                   &name, &value, ',');
 	}
 
 	/* Eat comma */
-	if (!pj_scan_is_eof(scanner) && *scanner->current == ',')
+	if (!pj_scan_is_eof(scanner) && *scanner->curptr == ',')
 	    pj_scan_get_char(scanner);
 	else
@@ -144,22 +155,23 @@
 }
 
-static void parse_pgp_challenge( pj_scanner *scanner, pj_pool_t *pool, pjsip_pgp_challenge *chal)
-{
-    PJ_UNUSED_ARG(scanner)
-    PJ_UNUSED_ARG(pool)
-    PJ_UNUSED_ARG(chal)
+static void parse_pgp_challenge( pj_scanner *scanner, pj_pool_t *pool, 
+                                 pjsip_pgp_challenge *chal)
+{
+    PJ_UNUSED_ARG(scanner);
+    PJ_UNUSED_ARG(pool);
+    PJ_UNUSED_ARG(chal);
 
     PJ_THROW(PJSIP_SYN_ERR_EXCEPTION);
 }
 
-static void int_parse_hdr_authorization( pj_scanner *scanner, pj_pool_t *pool, 
+static void int_parse_hdr_authorization( pj_scanner *scanner, pj_pool_t *pool,
 					 pjsip_authorization_hdr *hdr)
 {
-    if (*scanner->current == '"') {
+    if (*scanner->curptr == '"') {
 	pj_scan_get_quote(scanner, '"', '"', &hdr->scheme);
 	hdr->scheme.ptr++;
 	hdr->scheme.slen -= 2;
     } else {
-	pj_scan_get(scanner, pjsip_TOKEN_SPEC, &hdr->scheme);
+	pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &hdr->scheme);
     }
 
@@ -182,10 +194,10 @@
 					pjsip_www_authenticate_hdr *hdr)
 {
-    if (*scanner->current == '"') {
+    if (*scanner->curptr == '"') {
 	pj_scan_get_quote(scanner, '"', '"', &hdr->scheme);
 	hdr->scheme.ptr++;
 	hdr->scheme.slen -= 2;
     } else {
-	pj_scan_get(scanner, pjsip_TOKEN_SPEC, &hdr->scheme);
+	pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &hdr->scheme);
     }
 
@@ -206,39 +218,54 @@
 
 
-static pjsip_authorization_hdr *parse_hdr_authorization( pj_scanner *scanner, pj_pool_t *pool)
-{
-    pjsip_authorization_hdr *hdr = pjsip_authorization_hdr_create(pool);
-    int_parse_hdr_authorization(scanner, pool, hdr);
-    return hdr;
-}
-
-static pjsip_proxy_authorization_hdr *parse_hdr_proxy_authorization( pj_scanner *scanner, pj_pool_t *pool)
-{
-    pjsip_proxy_authorization_hdr *hdr = pjsip_proxy_authorization_hdr_create(pool);
-    int_parse_hdr_authorization(scanner, pool, hdr);
-    return hdr;
-}
-
-static pjsip_www_authenticate_hdr *parse_hdr_www_authenticate( pj_scanner *scanner, pj_pool_t *pool)
-{
-    pjsip_www_authenticate_hdr *hdr = pjsip_www_authenticate_hdr_create(pool);
-    int_parse_hdr_authenticate(scanner, pool, hdr);
-    return hdr;
-}
-
-static pjsip_proxy_authenticate_hdr *parse_hdr_proxy_authenticate( pj_scanner *scanner, pj_pool_t *pool)
-{
-    pjsip_proxy_authenticate_hdr *hdr = pjsip_proxy_authenticate_hdr_create(pool);
-    int_parse_hdr_authenticate(scanner, pool, hdr);
-    return hdr;
-}
-
-
-PJ_DEF(void) pjsip_auth_init_parser()
-{
-    pjsip_register_hdr_parser( "Authorization", NULL, (pjsip_parse_hdr_func*) &parse_hdr_authorization);
-    pjsip_register_hdr_parser( "Proxy-Authorization", NULL, (pjsip_parse_hdr_func*) &parse_hdr_proxy_authorization);
-    pjsip_register_hdr_parser( "WWW-Authenticate", NULL, (pjsip_parse_hdr_func*) &parse_hdr_www_authenticate);
-    pjsip_register_hdr_parser( "Proxy-Authenticate", NULL, (pjsip_parse_hdr_func*) &parse_hdr_proxy_authenticate);
+static pjsip_hdr* parse_hdr_authorization( pjsip_parse_ctx *ctx )
+{
+    pjsip_authorization_hdr *hdr = pjsip_authorization_hdr_create(ctx->pool);
+    int_parse_hdr_authorization(ctx->scanner, ctx->pool, hdr);
+    return (pjsip_hdr*)hdr;
+}
+
+static pjsip_hdr* parse_hdr_proxy_authorization( pjsip_parse_ctx *ctx )
+{
+    pjsip_proxy_authorization_hdr *hdr = 
+        pjsip_proxy_authorization_hdr_create(ctx->pool);
+    int_parse_hdr_authorization(ctx->scanner, ctx->pool, hdr);
+    return (pjsip_hdr*)hdr;
+}
+
+static pjsip_hdr* parse_hdr_www_authenticate( pjsip_parse_ctx *ctx )
+{
+    pjsip_www_authenticate_hdr *hdr = 
+        pjsip_www_authenticate_hdr_create(ctx->pool);
+    int_parse_hdr_authenticate(ctx->scanner, ctx->pool, hdr);
+    return (pjsip_hdr*)hdr;
+}
+
+static pjsip_hdr* parse_hdr_proxy_authenticate( pjsip_parse_ctx *ctx )
+{
+    pjsip_proxy_authenticate_hdr *hdr = 
+        pjsip_proxy_authenticate_hdr_create(ctx->pool);
+    int_parse_hdr_authenticate(ctx->scanner, ctx->pool, hdr);
+    return (pjsip_hdr*)hdr;
+}
+
+
+PJ_DEF(pj_status_t) pjsip_auth_init_parser()
+{
+    pj_status_t status;
+
+    status = pjsip_register_hdr_parser( "Authorization", NULL, 
+                                        &parse_hdr_authorization);
+    PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
+    status = pjsip_register_hdr_parser( "Proxy-Authorization", NULL, 
+                                        &parse_hdr_proxy_authorization);
+    PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
+    status = pjsip_register_hdr_parser( "WWW-Authenticate", NULL, 
+                                        &parse_hdr_www_authenticate);
+    PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
+    status = pjsip_register_hdr_parser( "Proxy-Authenticate", NULL, 
+                                        &parse_hdr_proxy_authenticate);
+    PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
+
+    return PJ_SUCCESS;
 }
 
